/*
 * CPolynomial.cpp
 *
 *  Created on: Dec 2, 2013
 *      Author: Jono 
 */

#include "CBasicPolynomial.h"


/*
***************************
******   PUBLIC     *******
*************************** 
*/




Interval CBasicPolynomial::value( GeometricCube geom_input ){
  /* We calculate and return the value of the function */

  Interval x = geom_input.coordinates_[0];
  Interval y = geom_input.coordinates_[1];
  /*
   * WARNING
   * Because of how the interval type is set to double, you cannot add/multiply/etc an interval by an integer.
   * 2*x		BAD
   * 2.0*x		GOOD
   * 2.*x		GOOD
   */
  Interval output =
	  20.*(-1.05 + y)*(-0.8 + y)*(-0.6 + y)*(-0.1 + y)*(0.1 + y)
	  - 10.*(-0.95 + x)*(-0.7 + x)*(-0.2 + x)*(0.01 + x);


  return output;
}


std::vector<Interval> CBasicPolynomial::derivative( GeometricCube geom_input  ){
  /* Initialize the output vector */
  std::vector<Interval> output;
  Interval x = geom_input.coordinates_[0];
  Interval y = geom_input.coordinates_[1];
  /* We calculate the x-derivative.*/
  Interval x_derivative =
	  -10.*((-0.95 + x)*(-0.7 + x)*(-0.2 + x) +
	  (-0.95 + x)*(-0.7 + x)*(0.01 + x) +
	  (-0.95 + x)*(-0.2 + x)*(0.01 + x) +
	  (-0.7 + x)*(-0.2 + x)*(0.01 + x)
	  );
  /*  We calculate the y-derivative.*/
  Interval y_derivative =
	  20.*((-1.05 + y)*(-0.8 + y)*(-0.6 + y)*(-0.1 + y) +
	  (-1.05 + y)*(-0.8 + y)*(-0.6 + y)*(0.1 + y) +
	  (-1.05 + y)*(-0.8 + y)*(-0.1 + y)*(0.1 + y) +
	  (-1.05 + y)*(-0.6 + y)*(-0.1 + y)*(0.1 + y) +
	  (-0.8 + y)*(-0.6 + y)*(-0.1 + y)*(0.1 + y)
	  );
  

  /* We add the x- and y- derivatives to the output. */
  output.push_back(x_derivative);
  output.push_back(y_derivative);
  return output ;
}

/*
*********************************
******   Constructors     *******
*********************************
*/


//  Generic Constructor
CBasicPolynomial::CBasicPolynomial(){
}

/* Copy constructor */
CBasicPolynomial::CBasicPolynomial(const CBasicPolynomial& poly){
}

// Destructor
CBasicPolynomial::~CBasicPolynomial(){
}


