/*
 * CComplex.h
 *
 *  Created on: Dec 6, 2013
 *      Author: Jono
 */

#ifndef CCOMPLEX_H_
#define CCOMPLEX_H_

#include "CNode.h"
#include "SFace.h"
#include <vector>
#include <iostream>
#include <stack> 
#include <algorithm>



class CComplex {

  private:
    bool                        element_of(int element, std::vector <unsigned  int > list );
    bool                        total_cover_test( std::vector <unsigned int > splitting_path ,int face);
    bool                        Extension( std::vector<unsigned int >  vector_1 , std::vector< unsigned int > vector_2 , int dimension);
    std::vector < bool  >       Face_Degeneracies( int face_number_);
    std::vector< int >          Tensor_Cells( std::vector< bool>  x_cells, std::vector< bool>  y_cells);
    void                        Prune_Node(  CNode* pt_node) ; 
    std::vector< bool >         infer_faces(  std::vector< bool >  faces );
    std::vector < SFace >       Redundant_Cells_Assisted(  SFace in_face ,SFace total_cover ) ;
    SFace                       Ascend( CNode * in_node , int face ) ;
   


  protected:
    /* The data we store is the root of the tree/complex */
    CNode root;

    std::vector< int >          Intersecting_Faces( SFace cube, SFace cell);
    bool                        Intersect_Cube( SFace cube, SFace cell);
	std::vector < SFace >       Redundant_Cells(SFace in_face);
   


  public:
    CNode*                      get_node( std::vector< unsigned int > location );
    std::vector< unsigned int > get_location( CNode* in_node );
    	
    void                        Add_Cube( std::vector< unsigned int > location , std::vector< bool >  vertices  );
    std::vector < SFace >       Obtain_Carrier(  SFace in_face  ) ;
    void                        Create_CW_Complex( void ) ; 
    std::vector < SFace >       Boundary( SFace in_face , bool sign);
   
    void                        Print(void );


};

#endif /* CCOMPLEX_H_ */
