/*
 * CPolynomial.h
 *
 *  Created on: Dec 2, 2013
 *      Author: jono and miro
 */

#ifndef CPOLYNOMIAL_H_
#define CPOLYNOMIAL_H_

#include "CBasicPolynomial.h"
#include "SGeometricCube.h"
#include <vector>
#include <iostream>
#include <cmath>




class CPolynomial : public CBasicPolynomial  
{
  private:
	  /* Interval_Subdivisions_ is an unsigned integer which dictates how many times a Geometric Cube is subdivided when performing interval arithmetic.*/
	  unsigned int Interval_Subdivisions_;


    std::vector < GeometricCube > Subdivide( std::vector<GeometricCube> cube_list_in ); 
    std::vector < GeometricCube > Multiple_Subdivisions(GeometricCube geom_input);
    
    Interval value_efficient( GeometricCube input); //
    /* Calculates the value of the function's Jacobian on the input cube. */ 
    std::vector<Interval> derivative_efficient( GeometricCube input);
    
  public:
    /* Determines whether the GeometricCube is verified by sign, at the given threshold */
    bool value_test( GeometricCube input, double threshold ); //
    /* Determines whether the partial derivatives are bounded away from zero */
    std::vector<bool> derivative_test( GeometricCube input); //
	/* Defines the number of subdivisions used in the interval arithmetic */
	void Define_Interval_Subdivisions(unsigned int New_Subdivisions){
		Interval_Subdivisions_ = New_Subdivisions;
	};
}; 
#endif /* CPOLYNOMIAL_H_ */

